
#include "common.h"

/*
 * ===================================
 * Return elapsed time from the last call
 *
 * FIXME: the first call is not accurate
 * reason currentTime - 0
 * ===================================
 */
__int64 CALLCONV PB_GetTimeDelta( long resolution )
{
	static unsigned __int64 lastTime;
	unsigned __int64 currentTime;
	unsigned __int64 deltaTime;

	QueryPerformanceCounter( (LARGE_INTEGER*)&currentTime );

	deltaTime	= currentTime - lastTime;
	lastTime	= currentTime;

	switch ( resolution ) 
	{
	case PB_TIME_SECOND :
		return deltaTime / rawFrequency_g;
		break;
	case PB_TIME_DECISECOND :
		return deltaTime / dsFrequency_g;
		break;
	case PB_TIME_CENTISECOND :
		return deltaTime / csFrequency_g;
		break;
	case PB_TIME_MILLISECOND :
		return deltaTime / msFrequency_g;
		break;
	case PB_TIME_MICROSECOND :
		return deltaTime / usFrequency_g;
		break;
	case PB_TIME_NANOSECOND :
		return deltaTime / nsFrequency_g;
		break;
	}

	return 0;
}