#include <stdlib.h>
#include <intrin.h>
#include <windows.h>

/*
#define PB_TIME_SECOND			0x0001
#define PB_TIME_DECISECOND		0x0002
#define PB_TIME_CENTISECOND		0x0003
#define PB_TIME_MILLISECOND		0x0004
#define PB_TIME_MICROSECOND		0x0005
#define PB_TIME_NANOSECOND		0x0006
*/

enum timerResolution {
  PB_TIME_NONE,
  PB_TIME_SECOND,
  PB_TIME_DECISECOND,
  PB_TIME_CENTISECOND,
	PB_TIME_MILLISECOND,
	PB_TIME_MICROSECOND,
	PB_TIME_NANOSECOND,
	PB_TIME_END
};

typedef __int64 quad;

#ifdef x86
    #define CALLCONV __stdcall
    typedef __int32 integer;
#else
    #define CALLCONV
    typedef quad integer;
#endif
    

extern unsigned __int64 startTime_g;
extern unsigned __int64 rawFrequency_g;
extern float dsFrequency_g;
extern float csFrequency_g;
extern float msFrequency_g;
extern float usFrequency_g;
extern float nsFrequency_g;

void CALLCONV PB_DEBUGGER_SendError(const char *Message);

/*
 * object stuff
 */
struct PB_ObjectStructure;
typedef struct PB_ObjectStructure PB_Object;

typedef void (CALLCONV *ObjectFreeFunction)(integer ID);
typedef int  (CALLCONV *ObjectEnumerateAllCallback)(integer ID, void *Element, void *Data);

void * CALLCONV PB_Object_GetOrAllocateID(PB_Object *Object, integer ID);
void * CALLCONV PB_Object_GetObject      (PB_Object *Object, integer DynamicOrArrayID);
void * CALLCONV PB_Object_IsObject       (PB_Object *Object, integer DynamicOrArrayID);
void   CALLCONV PB_Object_EnumerateAll   (PB_Object *Object, ObjectEnumerateAllCallback Callback, void *Data);
void   CALLCONV PB_Object_EnumerateStart (PB_Object *Object);
void * CALLCONV PB_Object_EnumerateNext  (PB_Object *Object, integer *ID);
void   CALLCONV PB_Object_EnumerateAbort (PB_Object *Object);
void   CALLCONV PB_Object_FreeID         (PB_Object *Object, integer DynamicOrArrayID);
void   CALLCONV PB_Object_CleanAll       (PB_Object *Object);
PB_Object * CALLCONV PB_Object_Init      (int StructureSize, int IncrementStep, ObjectFreeFunction FreeID);
integer CALLCONV PB_Object_Count         (PB_Object *Object);


typedef void (*CallbackProto)(void);

typedef struct
{
  integer handle;
  quad timeOut;
  quad timeInterval;
  quad intervalTicks;
  long resolution;
  long status;
  CallbackProto callback;
} PB_Timer;

enum timerStatus {
  PB_TIMERSTATUS_NONE,
	PB_TIMERSTATUS_WAIT,
	PB_TIMERSTATUS_RING,
	PB_TIMERSTATUS_END
};

extern PB_Object *PB_Timer_Objects;

#define PB_Timer_GetOrAllocateID(TIMER_ID) ((PB_Timer *)PB_Object_GetOrAllocateID (PB_Timer_Objects, TIMER_ID))
//#define PB_Timer_GetObject(TIMER_ID)       ((PB_Timer *)PB_Object_IsObject       (PB_Timer_Objects, TIMER_ID))
#define PB_Timer_GetObject(TIMER_ID)       ((PB_Timer *)PB_Object_GetObject       (PB_Timer_Objects, TIMER_ID))
#define PB_Timer_FreeID(TIMER_ID)                       PB_Object_FreeID          (PB_Timer_Objects, TIMER_ID)